#include <avr/io.h>
#include <stdlib.h>

#define F_CPU 16000000UL
#define BAUD 1200UL

#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD)

#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
  #error BAUDRATEN ERROR!
#endif



void uart_init(void)
{
  UBRRH = UBRR_VAL >> 8;
  UBRRL = UBRR_VAL & 0xFF;

  UCSRB = (1<<RXEN)|(1<<TXEN);
  UCSRC = (1<<URSEL)|(3<<UCSZ0);
}

int uart_putc(unsigned char d)
{
    while (!(UCSRA & (1<<UDRE)))
    {
    }

    UDR = d;
    return 0;
}


uint8_t uart_getc(void)
{
    while (!(UCSRA & (1<<RXC)))
        ;
    return UDR;
}

int main(void)
{
  uart_init();
   DDRA  = 0xFF;             
   DDRB  = 0xFF;             
   PORTB = 0x03;             

  while (1)
  {


    if ( (UCSRA & (1<<RXC)) )
    {
		uint8_t c;
		c = uart_getc();
		uart_putc(c);

		PORTA = c;
    }
    else
    {

    }
  }
  return 0; // never reached
}
